VERSION 5.00
Begin VB.Form frmCaptureScreen 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   BorderStyle     =   0  'None
   Caption         =   "Capture and Print Example"
   ClientHeight    =   6495
   ClientLeft      =   -75
   ClientTop       =   -15
   ClientWidth     =   9015
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   7.5
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   6495
   ScaleWidth      =   9015
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picsnapshot 
      BorderStyle     =   0  'None
      Height          =   2055
      Left            =   5640
      ScaleHeight     =   2055
      ScaleWidth      =   2415
      TabIndex        =   1
      Top             =   1800
      Width           =   2415
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Label1"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   24
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000FF&
         Height          =   540
         Left            =   600
         TabIndex        =   2
         Top             =   480
         Width           =   1410
      End
   End
   Begin VB.PictureBox piccontainer 
      BorderStyle     =   0  'None
      Height          =   3735
      Left            =   120
      ScaleHeight     =   3735
      ScaleWidth      =   5175
      TabIndex        =   0
      Top             =   960
      Width           =   5175
   End
   Begin VB.Image imgSizeBox 
      Height          =   300
      Left            =   8760
      Picture         =   "frmCaptureScreen.frx":0000
      Top             =   6240
      Width           =   300
   End
End
Attribute VB_Name = "frmCaptureScreen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'CaptureScreen Program
'
'Author Ben Vonk
'19-10-2013 1.0.0 Example how to Capturing a full screen, Active form, form and client also with layered windows. And can also be saved and print
'28-10-2013 1.1.0 Add SavePictureAsEMF (Enhanced Meta Format), ScrollBars with MouseWheel support, Resize restrictions.
'08-11-2013 1.2.0 Add Imagebox as SizeBox

Option Explicit

'Private Types
Private Type CommonControlsEx
   dwSize                   As Long
   dwICC                    As Long
End Type

Private Type GUID
   Data1                    As Long
   Data2                    As Integer
   Data3                    As Integer
   Data4(7)                 As Byte
End Type

Private Type EncoderParameter
   GUID                     As GUID
   NumberOfValues           As Long
   Type                     As Long
   value                    As Long
End Type

Private Type EncoderParameters
   Count                    As Long
   Parameter                As EncoderParameter
End Type

Private Type GdiplusStartupInput
   GdiplusVersion           As Long
   DebugEventCallback       As Long
   SuppressBackgroundThread As Long
   SuppressExternalCodecs   As Long
End Type

Private Type ImageCodecInfo
   ClassID                  As GUID
   FormatID                 As GUID
   CodecName                As Long
   DllName                  As Long
   FormatDescription        As Long
   FilenameExtension        As Long
   MimeType                 As Long
   flags                    As Long
   Version                  As Long
   SigCount                 As Long
   SigSize                  As Long
   SigPattern               As Long
   SigMask                  As Long
End Type

Private Type SHItemID
   cb                       As Long
   abID                     As Byte
End Type

Private Type ItemIDList
   mkid                     As SHItemID
End Type

Private Type PaletteEntry
   peRed                    As Byte
   peGreen                  As Byte
   peBlue                   As Byte
   peFlags                  As Byte
End Type

Private Type LogPalette
   palVersion               As Integer
   palNumEntries            As Integer
   palPalEntry(255)         As PaletteEntry
End Type

Private Type OpenFileName
   lStructSize              As Long
   hWndOwner                As Long
   hInstance                As Long
   lpstrFilter              As String
   lpstrCustomFilter        As String
   nMaxCustFilter           As Long
   nFilterIndex             As Long
   lpstrFile                As String
   nMaxFile                 As Long
   lpstrFileTitle           As String
   nMaxFileTitle            As Long
   lpstrInitialDir          As String
   lpstrTitle               As String
   lFlags                   As Long
   nFileOffset              As Integer
   nFileExtension           As Integer
   lpstrDefExt              As String
   lCustData                As Long
   lpfnHook                 As Long
   lpTemplateName           As String
End Type

Private Type PicBmp
   Size                     As Long
   Type                     As Long
   hBmp                     As Long
   hPal                     As Long
   Reserved                 As Long
End Type

Private Type PointAPI
   X                        As Long
   Y                        As Long
End Type

Private Type Rect
   Left                     As Long
   Top                      As Long
   Right                    As Long
   Bottom                   As Long
End Type

'Private Variables
Private HorizontalHasFocus  As Boolean
Private ScrollHorizontal    As Boolean
Private VerticalHasFocus    As Boolean
Private WithGDIPlus         As Boolean
Private DefaultHeight       As Long
Private DefaultWidth        As Long

'Private API's
Private Declare Function InitCommonControlsEx Lib "ComCtl32" (lpInitCtrls As CommonControlsEx) As Boolean
Private Declare Function GetSaveFileName Lib "ComDlg32" Alias "GetSaveFileNameA" (pOpenfilename As OpenFileName) As Long
Private Declare Function BitBlt Lib "GDI32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CloseEnhMetaFile Lib "GDI32" (ByVal hDC As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "GDI32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "GDI32" (ByVal hDC As Long) As Long
Private Declare Function CreateEnhMetaFile Lib "GDI32" Alias "CreateEnhMetaFileA" (ByVal hdcRef As Long, ByVal lpFileName As String, ByRef lpRect As Rect, ByVal lpDescription As String) As Long
Private Declare Function CreatePalette Lib "GDI32" (lpLogPalette As LogPalette) As Long
Private Declare Function DeleteDC Lib "GDI32" (ByVal hDC As Long) As Long
Private Declare Function DeleteEnhMetaFile Lib "GDI32" (ByVal hEMF As Long) As Long
Private Declare Function GetDeviceCaps Lib "GDI32" (ByVal hDC As Long, ByVal iCapability As Long) As Long
Private Declare Function GetSystemPaletteEntries Lib "GDI32" (ByVal hDC As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PaletteEntry) As Long
Private Declare Function RealizePalette Lib "GDI32" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "GDI32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function SelectPalette Lib "GDI32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function SetStretchBltMode Lib "GDI32" (ByVal hDC As Long, ByVal nStretchMode As Long) As Long
Private Declare Function GdipCreateBitmapFromHBITMAP Lib "GDIPlus" (ByVal hbm As Long, ByVal hPal As Long, nBitmap As Long) As Long
Private Declare Function GdipDisposeImage Lib "GDIPlus" (ByVal Image As Long) As Long
Private Declare Function GdipGetImageEncoders Lib "GDIPlus" (ByVal numEncoders As Long, ByVal Size As Long, ByRef Encoders As Any) As Long
Private Declare Function GdipGetImageEncodersSize Lib "GDIPlus" (ByRef numEncoders As Long, ByRef Size As Long) As Long
Private Declare Function GdiplusStartup Lib "GDIPlus" (ByRef token As Long, ByRef lpInput As GdiplusStartupInput, Optional ByRef lpOutput As Any) As Long
Private Declare Function GdiplusShutdown Lib "GDIPlus" (ByVal token As Long) As Long
Private Declare Function GdipSaveImageToFile Lib "GDIPlus" (ByVal Image As Long, ByVal Filename As Long, ByRef clsidEncoder As GUID, ByRef encoderParams As Any) As Long
Private Declare Function GetModuleHandle Lib "Kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Private Declare Function GetProcAddress Lib "Kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function StrLen Lib "Kernel32" Alias "lstrlenW" (ByVal lpString As Long) As Long
Private Declare Function WideCharToMultiByte Lib "Kernel32" (ByVal codepage As Long, ByVal dwFlags As Long, lpWideCharStr As Any, ByVal cchWideChar As Long, lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long
Private Declare Function CLSIDFromString Lib "OLE32" (ByVal lpsz As Long, ByRef pclsid As GUID) As Long
Private Declare Function OleCreatePictureIndirect Lib "OLEPro32" (PicDesc As PicBmp, RefIID As GUID, ByVal fpictureOwnsHandle As Long, IPic As IPicture) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hWndOwner As Long, ByVal nFolder As Long, pidl As ItemIDList) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As PointAPI) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long

Private Declare Sub InitCommonControls Lib "ComCtl32" ()
Private Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Public Sub SetScrollBars(ByVal wParam As Long)

Dim lngWindow  As Long
Dim ptaMouseXY As PointAPI

   If picsnapshot.Picture = 0 Then Exit Sub
   
   GetCursorPos ptaMouseXY
   lngWindow = WindowFromPoint(ptaMouseXY.X, ptaMouseXY.Y)
   
   If lngWindow = piccontainer.hwnd Then lngWindow = 0
   If lngWindow = picsnapshot.hwnd Then lngWindow = 0
 
   If lngWindow Then Exit Sub
   
   
End Sub

Private Function CaptureActiveWindow() As Picture

Dim lngWindow As Long
Dim rctWindow As Rect

   On Local Error GoTo ErrorRoutine
   lngWindow = GetForegroundWindow
   GetWindowRect lngWindow, rctWindow
   
   With rctWindow
      Set CaptureActiveWindow = CaptureWindow(lngWindow, 0, 0, .Right - .Left, .Bottom - .Top)
   End With
   
ExitFunction:
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("CaptureActiveWindow")
   
   GoTo ExitFunction

End Function

Private Function CaptureClient(ByVal SrcForm As Form) As Picture

   On Local Error GoTo ErrorRoutine
   
   With SrcForm
      Set CaptureClient = CaptureWindow(.hwnd, 0, 0, .ScaleX(.ScaleWidth, .ScaleMode, vbPixels), .ScaleY(.ScaleHeight, .ScaleMode, vbPixels), True)
   End With
   
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("CaptureClient")
   
   Resume Next

End Function

Private Function CaptureForm(ByVal SrcForm As Form) As Picture

   On Local Error GoTo ErrorRoutine
   
   With SrcForm
      Set CaptureForm = CaptureWindow(.hwnd, 0, 0, .ScaleX(.Width, vbTwips, vbPixels), .ScaleY(.Height, vbTwips, vbPixels))
   End With
   
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("CaptureForm")
   
   Resume Next

End Function

Private Function CaptureFullScreen() As Picture

   On Error GoTo ErrorRoutine
   
   With Screen
      Set CaptureFullScreen = CaptureWindow(GetDesktopWindow, 0, 0, .Width \ .TwipsPerPixelX, .Height \ .TwipsPerPixelY)
   End With
   
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("CaptureFullScreen")
   
   Resume Next

End Function

Private Function CaptureWindow(ByVal hwnd As Long, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, Optional ByVal Client As Boolean) As Picture

Const CAPTUREBLT         As Long = &H40000000
Const RASTERCAPS         As Long = 38
Const RC_PALETTE         As Long = &H100
Const SIZEPALETTE        As Long = 104

Dim lgpPaletteInfo       As LogPalette
Dim lngBitmap            As Long
Dim lngDC                As Long
Dim lngHasPaletteScreen  As Long
Dim lngMemoryDC          As Long
Dim lngPal               As Long
Dim lngPaletteSizeScreen As Long
Dim lngPreviousBitmap    As Long
Dim lngPreviousPal       As Long
Dim lngRasterCapsScreen  As Long

   On Local Error GoTo ErrorRoutine
   DoEvents
   
   If Client Then
      lngDC = GetDC(hwnd)
      
   Else
      lngDC = GetWindowDC(hwnd)
   End If
   
   lngMemoryDC = CreateCompatibleDC(lngDC)
   lngBitmap = CreateCompatibleBitmap(lngDC, Width, Height)
   lngPreviousBitmap = SelectObject(lngMemoryDC, lngBitmap)
   lngRasterCapsScreen = GetDeviceCaps(lngDC, RASTERCAPS)
   lngHasPaletteScreen = lngRasterCapsScreen And RC_PALETTE
   lngPaletteSizeScreen = GetDeviceCaps(lngDC, SIZEPALETTE)
   
   If lngHasPaletteScreen And (lngPaletteSizeScreen = 256) Then
      With lgpPaletteInfo
         .palVersion = &H300
         .palNumEntries = 256
         GetSystemPaletteEntries lngDC, 0, 256, .palPalEntry(0)
      End With
      
      lngPal = CreatePalette(lgpPaletteInfo)
      lngPreviousPal = SelectPalette(lngMemoryDC, lngPal, 0)
      RealizePalette lngMemoryDC
   End If
   
   BitBlt lngMemoryDC, 0, 0, Width, Height, lngDC, Left, Top, vbSrcCopy Or (CAPTUREBLT And IsLayeredOS)
   lngBitmap = SelectObject(lngMemoryDC, lngPreviousBitmap)
   
   If lngHasPaletteScreen And (lngPaletteSizeScreen = 256) Then lngPal = SelectPalette(lngMemoryDC, lngPreviousPal, 0)
   
ExitFunction:
   If lngMemoryDC Then DeleteDC lngMemoryDC
   If lngDC Then ReleaseDC hwnd, lngDC
   If lngBitmap Then Set CaptureWindow = CreateBitmapPicture(lngBitmap, lngPal)
   
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("CaptureWindow")
   
   GoTo ExitFunction

End Function

Private Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture

Dim ipcBitmap      As IPicture
Dim gidIIDDisPatch As GUID
Dim bmpPicture     As PicBmp

   On Local Error GoTo ErrorRoutine
   
   With gidIIDDisPatch
      .Data1 = &H20400
      .Data4(0) = &HC0
      .Data4(7) = &H46
   End With
   
   With bmpPicture
      .Size = Len(bmpPicture)
      .Type = vbPicTypeBitmap
      .hBmp = hBmp
      .hPal = hPal
   End With
   
ExitFunction:
   If bmpPicture.hBmp Then OleCreatePictureIndirect bmpPicture, gidIIDDisPatch, 1, ipcBitmap
   If Not ipcBitmap Is Nothing Then Set CreateBitmapPicture = ipcBitmap
   
   Set ipcBitmap = Nothing
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("CreateBitmapPicture")
   
   bmpPicture.hBmp = 0
   Set ipcBitmap = Nothing
   GoTo ExitFunction

End Function

Private Function GetEncoderClassId(ByVal MimeType As String, ByRef ClassID As GUID) As Boolean

Dim bytBuffer()    As Byte
Dim imgCodecInfo() As ImageCodecInfo
Dim lngCount       As Long
Dim lngEncoders    As Long
Dim lngSize        As Long

   GdipGetImageEncodersSize lngEncoders, lngSize
   
   If lngSize Then
      ReDim bytBuffer(lngSize) As Byte
      ReDim imgCodecInfo(lngEncoders) As ImageCodecInfo
      
      GdipGetImageEncoders lngEncoders, lngSize, bytBuffer(0)
      
      Call CopyMemory(imgCodecInfo(0), bytBuffer(0), (Len(imgCodecInfo(0)) * lngEncoders))
      
      For lngCount = 0 To lngEncoders - 1
         'Check for: image/bmp, image/jpeg, image/png, image/gif, image/tiff
         If StrComp(GetStringFromPointer(imgCodecInfo(lngCount).MimeType), MimeType, vbTextCompare) = 0 Then
            ClassID = imgCodecInfo(lngCount).ClassID
            GetEncoderClassId = True
            Exit For
         End If
      Next 'lngCount
      
      Erase bytBuffer
      Erase imgCodecInfo
   End If

End Function

Private Function GetMyPicturesFolder() As String

Const CSIDL_MYPICTURES As Long = &H27
Const ERROR_SUCCESS    As Long = &H0

Dim iidList            As ItemIDList
Dim strFolder          As String * 512

   If SHGetSpecialFolderLocation(100, CSIDL_MYPICTURES, iidList) = ERROR_SUCCESS Then
      SHGetPathFromIDList ByVal iidList.mkid.cb, ByVal strFolder
      GetMyPicturesFolder = StripNull(strFolder)
   End If

End Function

Private Function GetPictureFileName(ByVal FileFolder As String) As String

Const OFN_CREATEPROMPT       As Long = &H2000
Const OFN_EXPLORER           As Long = &H80000
Const OFN_HIDEREADONLY       As Long = &H4
Const OFN_LONGNAMES          As Long = &H200000
Const OFN_NODEREFERENCELINKS As Long = &H100000

Dim intChoose                As Integer
Dim intItem                  As Integer
Dim intMaxItems              As Integer
Dim ofnInfo                  As OpenFileName
Dim strFileExtension()       As String
Dim strFileFormat            As String

   On Local Error GoTo ErrorRoutine
   intMaxItems = 2 + (4 And WithGDIPlus)
   
   ReDim strFileExtension(intMaxItems) As String
   
   For intItem = 1 To intMaxItems
      If (intItem = 2) And (intMaxItems = 2) Then
         intChoose = 6
         
      Else
         intChoose = intItem
      End If
      
      strFileFormat = "*." & Choose(intChoose, "bmp", "jpg", "png", "gif", "tif", "emf")
      strFileExtension(intItem) = UCase(Mid(strFileFormat, 3)) & " (" & strFileFormat & ")" & Chr(0) & strFileFormat & Chr(0)
      strFileExtension(0) = strFileExtension(0) & strFileExtension(intItem)
   Next 'intItem
   
   With ofnInfo
      .lStructSize = Len(ofnInfo)
      .hWndOwner = hwnd
      .hInstance = App.hInstance
      'Set the file extensions
      .lpstrFilter = strFileExtension(0)
      .lpstrFile = Space(254)
      .nMaxFile = 255
      .lpstrFileTitle = Space(254)
      .nMaxFileTitle = 255
      .lpstrInitialDir = FileFolder
      'Set the dialog title
      .lpstrTitle = "Save CaptureScreen"
      .lFlags = OFN_EXPLORER Or OFN_LONGNAMES Or OFN_CREATEPROMPT Or OFN_NODEREFERENCELINKS Or OFN_HIDEREADONLY
      
      If GetSaveFileName(ofnInfo) Then
         strFileFormat = strFileExtension(.nFilterIndex)
         GetPictureFileName = StripNull(ofnInfo.lpstrFile) & StripNull(Mid(strFileFormat, InStrRev(strFileFormat, ".")))
      End If
   End With
   
ExitFunction:
   Erase strFileExtension
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("GetPictureFileName")
   
   GoTo ExitFunction

End Function

Private Function GetStringFromPointer(ByVal Pointer As Long) As String

Const CP_ACP As Long = 0

Dim strText  As String

   strText = String(StrLen(ByVal Pointer) * 2, vbNullChar)
   WideCharToMultiByte CP_ACP, 0, ByVal Pointer, -1, ByVal strText, Len(strText), 0, 0
   GetStringFromPointer = StripNull(strText)

End Function

Private Function InitGDIPlus() As Boolean

Const GdiplusVersion  As Long = 1

Static blnInitialized As Boolean
Static lngToken       As Long

Dim gdiStartupInput   As GdiplusStartupInput

   On Local Error GoTo ExitFunction
   
   If blnInitialized Then
      GdiplusShutdown lngToken
      blnInitialized = False
      
   Else
      gdiStartupInput.GdiplusVersion = GdiplusVersion
      blnInitialized = (GdiplusStartup(lngToken, gdiStartupInput, ByVal 0&) = 0)
      InitGDIPlus = blnInitialized
   End If
   
ExitFunction:
   On Local Error GoTo 0

End Function

Private Function IsLayeredOS() As Boolean

  IsLayeredOS = (GetProcAddress(GetModuleHandle("User32.dll"), "SetLayeredWindowAttributes") <> 0)

End Function

Private Function SavePictureAs(ByVal Handle As Long, ByVal Filename As String, Optional ByVal JpgQuality As Byte = 100) As Boolean

Const ENCODER_TYPE        As Long = &H4
Const ENCODER_COMPRESSION As Long = &H2

Dim encParameters         As EncoderParameters
Dim gidEncoder            As GUID
Dim lngBitmap             As Long
Dim strImageID            As String

   On Local Error GoTo ErrorRoutine
   
   Select Case LCase(Right(Filename, 4))
      Case ".bmp"
         strImageID = "image/bmp"
         
      Case ".jpg"
         strImageID = "image/jpeg"
         
      Case ".png"
         strImageID = "image/png"
         
      Case ".gif"
         strImageID = "image/gif"
         
      Case ".tif"
         strImageID = "image/tiff"
         
      Case Else
         Exit Function
   End Select
   
   If GdipCreateBitmapFromHBITMAP(Handle, 0, lngBitmap) = 0 Then
      If GetEncoderClassId(strImageID, gidEncoder) Then
         If strImageID = "image/jpeg" Then
            CLSIDFromString StrPtr("{557CF401-1A04-11D3-9A73-0000F81EF32E}"), gidEncoder
            encParameters.Count = 1
            
            With encParameters.Parameter
               .NumberOfValues = 1
               .Type = ENCODER_TYPE
               CLSIDFromString StrPtr("{1D5BE4B5-FA4A-452D-9CDD-5DB35105E7EB}"), .GUID
               .value = VarPtr(JpgQuality)
            End With
            
            SavePictureAs = (GdipSaveImageToFile(lngBitmap, StrPtr(Filename), gidEncoder, encParameters) = 0)
            
         Else
            SavePictureAs = (GdipSaveImageToFile(lngBitmap, StrPtr(Filename), gidEncoder, ByVal 0&) = 0)
         End If
      End If
      
      GdipDisposeImage lngBitmap
   End If
   
ExitFunction:
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("SavePictureAs")
   
   GoTo ExitFunction

End Function

Private Function SavePictureAsEMF(ByVal Box As PictureBox, OutputFile As String) As Boolean

Const HORZRES          As Long = 8
Const HORZSIZE         As Long = 4
Const STRETCH_HALFTONE As Long = 4
Const VERTRES          As Long = 10
Const VERTSIZE         As Long = 6

Dim lngHeight          As Long
Dim lngHorzRes         As Long
Dim lngHorzSize        As Long
Dim lngMetaDC          As Long
Dim lngMode            As Long
Dim lngVertRes         As Long
Dim lngVertSize        As Long
Dim lngWidth           As Long
Dim rctWindow          As Rect

   On Local Error GoTo ErrorRoutine
   
   With Box
      lngHorzSize = GetDeviceCaps(.hDC, HORZSIZE) * 100
      lngVertSize = GetDeviceCaps(.hDC, VERTSIZE) * 100
      lngHorzRes = GetDeviceCaps(.hDC, HORZRES)
      lngVertRes = GetDeviceCaps(.hDC, VERTRES)
      lngWidth = ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
      lngHeight = ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
      
      With rctWindow
         .Top = 0
         .Left = 0
         .Right = (lngWidth * lngHorzSize) / lngHorzRes
         .Bottom = (lngHeight * lngVertSize) / lngVertRes
      End With
      
      lngMetaDC = CreateEnhMetaFile(.hDC, OutputFile, rctWindow, vbNullString)
      
      If lngMetaDC Then
         lngMode = SetStretchBltMode(lngMetaDC, STRETCH_HALFTONE)
         BitBlt lngMetaDC, 0, 0, lngWidth, lngHeight, .hDC, 0, 0, vbSrcCopy
         SetStretchBltMode lngMetaDC, lngMode
         SavePictureAsEMF = (DeleteEnhMetaFile(CloseEnhMetaFile(lngMetaDC)) = 1)
      End If
   End With
   
ExitFunction:
   On Local Error GoTo 0
   Exit Function
   
ErrorRoutine:
   Call ShowErrorMessage("SavePictureAsEMF")
   
   GoTo ExitFunction

End Function

Private Function StripNull(ByVal Text As String) As String

   StripNull = Left(Text, StrLen(StrPtr(Text)))

End Function

Private Sub CenterSnapShot()

Dim lngHeight As Long
Dim lngWidth  As Long

   lngHeight = piccontainer.Height
   lngWidth = piccontainer.Width
   
   With picsnapshot
      If .Height < lngHeight Then
         .Top = (lngHeight - .Height) / 2
         'sbrHorizontal.Max = 0
         
      Else
         .Top = 0
         'sbrHorizontal.Max = .Width - lngWidth
         'ScrollHorizontal = True
      End If
      
      If .Width < lngWidth Then
         .Left = (lngWidth - .Width) / 2
         'sbrVertical.Max = 0
         
      Else
         .Left = 0
         'sbrVertical.Max = .Height - lngHeight
         'ScrollHorizontal = False
      End If
      
      'sbrHorizontal.TabStop = (.Picture <> 0)
      'sbrVertical.TabStop = (.Picture <> 0)
   End With

End Sub

Private Sub InitializeCommonControls()

Const ICC_USEREX_CLASSES As Long = &H200
Const ICC_WIN95_CLASSES  As Long = &HFF

Dim iccInitialize        As CommonControlsEx

   On Local Error GoTo IsOldVersion
   
   With iccInitialize
      .dwSize = Len(iccInitialize)
      .dwICC = ICC_WIN95_CLASSES Or ICC_USEREX_CLASSES
   End With
   
   If InitCommonControlsEx(iccInitialize) Then GoTo ExitFunction
   
IsOldVersion:
   Call InitCommonControls
   
ExitFunction:
   On Local Error GoTo 0

End Sub

Private Sub PrintPictureToFitPage(ByVal IsPrinter As Printer, ByVal IsPicture As Picture)

Dim blnPrinting             As Boolean
Dim sngPictureRatio         As Single
Dim sngPrinterHeight        As Single
Dim sngPrinterPictureHeight As Single
Dim sngPrinterPictureWidth  As Single
Dim sngPrinterRatio         As Single
Dim sngPrinterWidth         As Single

   If IsPicture = 0 Then Exit Sub
   
   On Local Error GoTo ErrorRoutine

   With IsPrinter
      If .Height >= .Width Then
         .Orientation = vbPRORPortrait
         
      Else
         .Orientation = vbPRORLandscape
      End If
      
      sngPictureRatio = .Width / .Height
      sngPrinterWidth = .ScaleX(.ScaleWidth, .ScaleMode, vbHimetric)
      sngPrinterHeight = .ScaleY(.ScaleHeight, .ScaleMode, vbHimetric)
      sngPrinterRatio = sngPrinterWidth / sngPrinterHeight
      
      If sngPictureRatio >= sngPrinterRatio Then
         sngPrinterPictureWidth = .ScaleX(sngPrinterWidth, vbHimetric, .ScaleMode)
         sngPrinterPictureHeight = .ScaleY(sngPrinterWidth / sngPictureRatio, vbHimetric, .ScaleMode)
         
      Else
         sngPrinterPictureWidth = .ScaleX(sngPrinterHeight * sngPictureRatio, vbHimetric, .ScaleMode)
         sngPrinterPictureHeight = .ScaleY(sngPrinterHeight, vbHimetric, .ScaleMode)
      End If
      
      blnPrinting = True
      .PaintPicture IsPicture, 0, 0, sngPrinterPictureWidth, sngPrinterPictureHeight
      .EndDoc
      blnPrinting = False
   End With
   
ExitFunction:
   On Local Error GoTo 0
   Exit Sub
   
ErrorRoutine:
   Call ShowErrorMessage("PrintPictureToFitPage")
   
   If blnPrinting Then IsPrinter.EndDoc
   
   GoTo ExitFunction

End Sub

Private Sub SavePictureToDisk()

Dim strFileFolder As String
Dim strFileName   As String

   If picsnapshot.Picture = 0 Then Exit Sub
   
   On Local Error GoTo ErrorRoutine
   strFileFolder = GetMyPicturesFolder
   
   If strFileFolder = "" Then strFileFolder = App.Path
   If Right(strFileFolder, 1) <> "\" Then strFileFolder = strFileFolder & "\"
   
   On Local Error GoTo 0
   strFileName = GetPictureFileName(strFileFolder)
   On Local Error GoTo ErrorRoutine
   
   If Len(strFileName) Then
      Screen.MousePointer = vbHourglass
      
      If Right(strFileName, 4) = ".emf" Then
         SavePictureAsEMF picsnapshot, strFileName
         
      ElseIf WithGDIPlus Then
         SavePictureAs picsnapshot.Picture.Handle, strFileName
         
      Else
         SavePicture picsnapshot.Picture, strFileName
      End If
   End If
   
ExitSub:
   Screen.MousePointer = vbDefault
   On Local Error GoTo 0
   Exit Sub
   
ErrorRoutine:
   Call ShowErrorMessage("SavePictureToDisk")
   
   GoTo ExitSub

End Sub

Private Sub SetScrollBarValue(ByVal ScrollBar As Object, ByVal wParam As Long)

Dim intValue As Integer

   With ScrollBar
      intValue = .value + .LargeChange - ((.LargeChange * 2) And (wParam > 0))
      
      If intValue < 0 Then intValue = 0
      If intValue > .Max Then intValue = .Max
      
      .value = intValue
   End With

End Sub

Private Sub ShowErrorMessage(ByVal InModule As String)

   With Err
      MsgBox "Project: " & .Source & vbCrLf & "Module: " & InModule & vbCrLf & "Number: " & .Number & vbCrLf & "Description: " & .Description, vbOKOnly + vbCritical, "Error in: " & Caption
      .Clear
   End With

End Sub

Private Sub Waiting(ByVal Seconds As Integer)

Dim dteEndTime As Date

   MsgBox Seconds & " seconds after you close this dialog " & vbCrLf & "the active window will be captured.", vbOKOnly + vbInformation, "Waiting....."
   dteEndTime = DateAdd("s", Seconds, Now)
   
   Do Until Now > dteEndTime
      DoEvents
   Loop

End Sub

Public Sub cmdCommand_Click(Index As Integer)



   Select Case Index
      Case 0
         Set picsnapshot.Picture = CaptureFullScreen
         
         Call CenterSnapShot
        
         
      Case 6
         With picsnapshot
            .Height = DefaultHeight
            .Width = DefaultWidth
            Set .Picture = Nothing
         End With
         
         Call CenterSnapShot
         
      Case 7
         Unload Me
   End Select

Me.Top = 0
Me.Left = 0
Me.Width = Screen.Width
Me.Height = Screen.Height

piccontainer.Width = Me.Width
piccontainer.Height = Me.Height
piccontainer.Left = 0
piccontainer.Top = 0




End Sub

Private Sub Form_Initialize()

   InitializeCommonControls
   WithGDIPlus = InitGDIPlus
   Icon = Nothing
   
'   If App.LogMode = 1 Then cmdCommand.Item(7).Left = cmdCommand.Item(7).Left + Screen.TwipsPerPixelX

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

   If picsnapshot.Picture = 0 Then Exit Sub
   
   Select Case KeyCode
      Case vbKeyLeft
         'Call SetScrollBarValue(sbrHorizontal, 1)
         
      Case vbKeyRight
         'Call SetScrollBarValue(sbrHorizontal, 0)
         
      Case vbKeyUp
         'Call SetScrollBarValue(sbrVertical, 1)
      
      Case vbKeyDown
         'Call SetScrollBarValue(sbrVertical, 0)
   End Select

End Sub

Private Sub Form_Load()

   'sbrHorizontal.SmallChange = Screen.TwipsPerPixelX * 30
   'sbrVertical.SmallChange = Screen.TwipsPerPixelY * 30
   DefaultHeight = picsnapshot.Height
   DefaultWidth = picsnapshot.Width
   'ScrollHorizontal = True
   
   Call SetSizes(ScaleX(Width, vbTwips, vbPixels), ScaleY(Height, vbTwips, vbPixels), ScaleX(Screen.Width, vbTwips, vbPixels), ScaleY(Screen.Height, vbTwips, vbPixels))
   Call SubClassForm(hwnd)
   
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

   Unload Me

End Sub

Private Sub Form_Resize()

piccontainer.Height = Me.Height
piccontainer.Width = Me.Width
piccontainer.Left = 0
piccontainer.Top = 0

picsnapshot.Height = Me.Height
picsnapshot.Width = Me.Width
picsnapshot.Left = 0
picsnapshot.Top = 0

   
   
   
   Call CenterSnapShot
   
End Sub

Private Sub Form_Unload(Cancel As Integer)

   Call SubClassForm
   
   If WithGDIPlus Then InitGDIPlus
   
   Set frmCaptureScreen = Nothing

End Sub

Private Sub imgSizeBox_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

Const HTBOTTOMRIGHT    As Long = 17
Const WM_NCLBUTTONDOWN As Long = &HA1

   If (Button = vbLeftButton) And (imgSizeBox.MousePointer = vbSizeNWSE) Then
      ReleaseCapture
      SendMessage hwnd, WM_NCLBUTTONDOWN, HTBOTTOMRIGHT, ByVal 0
   End If

End Sub

Private Sub imgSizeBox_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

   If WindowState = vbMaximized Then Exit Sub
   
   If (X / Screen.TwipsPerPixelX > 10) And (Y / Screen.TwipsPerPixelY > 10) Then
      imgSizeBox.MousePointer = vbSizeNWSE
      
   Else
      imgSizeBox.MousePointer = vbDefault
   End If

End Sub

Private Sub imgSizeBox_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

   If (Button = vbLeftButton) And (imgSizeBox.MousePointer = vbSizeNWSE) Then
      ReleaseCapture
      imgSizeBox.MousePointer = vbDefault
   End If

End Sub


        
 

