Attribute VB_Name = "mdlRestrictResize"
Option Explicit

'Private Type
Private Type PointAPI
    X                As Long
    Y                As Long
End Type

Private Type MinMaxInfo
   ptReserved        As PointAPI
   ptMaxSize         As PointAPI
   ptMaxPosition     As PointAPI
   ptMinTrackSize    As PointAPI
   ptMaxTrackSize    As PointAPI
End Type

'Private Variables
Private FormHandle   As Long
Private PrevProcForm As Long
Private MaxSizeX     As Long
Private MaxSizeY     As Long
Private MinSizeX     As Long
Private MinSizeY     As Long
Private FormSizes    As MinMaxInfo

'Private API's
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)

Public Sub SetSizes(ByVal MinX As Long, ByVal MinY As Long, ByVal MaxX As Long, ByVal MaxY As Long)

   MinSizeX = MinX
   MinSizeY = MinY
   MaxSizeX = MaxX
   MaxSizeY = MaxY

End Sub

Public Sub SubClassForm(Optional ByVal hwnd As Long)

Const GWL_WNDPROC As Long = -4

   On Local Error Resume Next
   
   If PrevProcForm Then
      SetWindowLong FormHandle, GWL_WNDPROC, PrevProcForm
      PrevProcForm = 0
      FormHandle = 0
      
   ElseIf hwnd Then
      PrevProcForm = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WindowProc)
      FormHandle = hwnd
   End If
   
   On Local Error GoTo 0

End Sub

Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Const WM_GETMINMAXINFO As Long = &H24
Const WM_MOUSEWHEEL    As Long = &H20A

   On Local Error Resume Next
   
   If hwnd = FormHandle Then
      If uMsg = WM_GETMINMAXINFO Then
         Call CopyMemory(FormSizes, ByVal lParam, LenB(FormSizes))
         
         With FormSizes
            .ptMinTrackSize.X = MinSizeX
            .ptMinTrackSize.Y = MinSizeY
            .ptMaxTrackSize.X = MaxSizeX
            .ptMaxTrackSize.Y = MaxSizeY
         End With
         
         Call CopyMemory(ByVal lParam, FormSizes, LenB(FormSizes))
         
         WindowProc = 0
         
      ElseIf uMsg = WM_MOUSEWHEEL Then
         'Call FormHarness.SetScrollBars(wParam)
         
         WindowProc = 0
         
      Else
         WindowProc = CallWindowProc(PrevProcForm, hwnd, uMsg, wParam, lParam)
      End If
   End If
   
   On Local Error GoTo 0

End Function
